package com.liang.dao;

import com.liang.entity.BaseSchool;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 学校(BaseSchool)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-23 12:57:00
 */
public interface BaseSchoolDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BaseSchool queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param baseSchool 查询条件
     * @param pageable   分页对象
     * @return 对象列表
     */
    List<BaseSchool> queryAllByLimit(BaseSchool baseSchool, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param baseSchool 查询条件
     * @return 总行数
     */
    long count(BaseSchool baseSchool);

    /**
     * 新增数据
     *
     * @param baseSchool 实例对象
     * @return 影响行数
     */
    int insert(BaseSchool baseSchool);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseSchool> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BaseSchool> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseSchool> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<BaseSchool> entities);

    /**
     * 修改数据
     *
     * @param baseSchool 实例对象
     * @return 影响行数
     */
    int update(BaseSchool baseSchool);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取所有数据
     *
     * @return
     */
    List<BaseSchool> queryAll();
}

